/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Thu Mar 27 11:45:44 2008.
 *
 * -----------------------------------------------------------------------
 *
 * ``The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved via the world wide web at http://www.erlang.org/.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Ericsson Utvecklings AB.
 * Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
 * AB. All Rights Reserved.''
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_ETS (7)
#define ERTS_ALC_A_FIXED_SIZE (8)
#define ERTS_ALC_A_BINARY (9)
#define ERTS_ALC_A_DRIVER (10)

#define ERTS_ALC_A_MAX (10)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_BINARIES  (3)
#define ERTS_ALC_C_ATOM  (4)
#define ERTS_ALC_C_SYSTEM  (5)
#define ERTS_ALC_C_CODE  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (8)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (9)
#define ERTS_ALC_N_MAX_A_TEMPORARY (24)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (25)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (39)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (40)
#define ERTS_ALC_N_MAX_A_STANDARD (76)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (77)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (102)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (103)
#define ERTS_ALC_N_MAX_A_EHEAP (105)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (106)
#define ERTS_ALC_N_MAX_A_ETS (113)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (114)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (125)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (126)
#define ERTS_ALC_N_MAX_A_BINARY (127)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (128)
#define ERTS_ALC_N_MAX_A_DRIVER (128)

#define ERTS_ALC_N_MAX (128)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (1)
#define ERTS_ALC_MTA_SHORT_LIVED (1)
#define ERTS_ALC_MTA_STANDARD (1)
#define ERTS_ALC_MTA_LONG_LIVED (1)
#define ERTS_ALC_MTA_EHEAP (1)
#define ERTS_ALC_MTA_ETS (1)
#define ERTS_ALC_MTA_FIXED_SIZE (1)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (209)
#define ERTS_ALC_T_NBIF_TABLE (337)
#define ERTS_ALC_T_ASYNC (465)
#define ERTS_ALC_T_INFO_DSBUF (593)
#define ERTS_ALC_T_ETHR_INTERNAL (721)
#define ERTS_ALC_T_HIPE (849)
#define ERTS_ALC_T_ENVIRONMENT (977)
#define ERTS_ALC_T_PUTENV_STR (1105)
#define ERTS_ALC_T_MSG_ROOTS (1170)
#define ERTS_ALC_T_ROOTSET (1298)
#define ERTS_ALC_T_LOADER_TMP (1506)
#define ERTS_ALC_T_NC_TMP (1618)
#define ERTS_ALC_T_TMP (1746)
#define ERTS_ALC_T_DCTRL_BUF (1874)
#define ERTS_ALC_T_TMP_DIST_BUF (2002)
#define ERTS_ALC_T_ESTACK (2130)
#define ERTS_ALC_T_PORT_CALL_BUF (2258)
#define ERTS_ALC_T_DB_TMP (2338)
#define ERTS_ALC_T_DB_MC_STK (2466)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2594)
#define ERTS_ALC_T_LOGGER_DSBUF (2770)
#define ERTS_ALC_T_TMP_DSBUF (2898)
#define ERTS_ALC_T_DDLL_TMP_BUF (3026)
#define ERTS_ALC_T_SYS_READ_BUF (3154)
#define ERTS_ALC_T_PEND_SUSPEND (3219)
#define ERTS_ALC_T_MSG_REF (3347)
#define ERTS_ALC_T_SL_BIF_TIMER (3475)
#define ERTS_ALC_T_DB_FIXATION (3619)
#define ERTS_ALC_T_DB_FIX_DEL (3747)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (3875)
#define ERTS_ALC_T_PORT_TASK (4051)
#define ERTS_ALC_T_PORT_TASKQ (4179)
#define ERTS_ALC_T_MISC_OP_LIST (4307)
#define ERTS_ALC_T_PORT_NAMES (4435)
#define ERTS_ALC_T_XPORTS_LIST (4563)
#define ERTS_ALC_T_SL_PTIMER (4691)
#define ERTS_ALC_T_SYS_MSG_Q (4755)
#define ERTS_ALC_T_FD_LIST (4947)
#define ERTS_ALC_T_POLLSET_UPDREQ (5075)
#define ERTS_ALC_T_LINK_LH (5140)
#define ERTS_ALC_T_MONITOR_LH (5268)
#define ERTS_ALC_T_NLINK_LH (5396)
#define ERTS_ALC_T_SUSPEND_MON (5524)
#define ERTS_ALC_T_LL_BIF_TIMER (5652)
#define ERTS_ALC_T_REG_TABLE (5844)
#define ERTS_ALC_T_FUN_TABLE (5988)
#define ERTS_ALC_T_DIST_TABLE (6100)
#define ERTS_ALC_T_NODE_TABLE (6228)
#define ERTS_ALC_T_MODULE_REFS (6372)
#define ERTS_ALC_T_DCACHE (6484)
#define ERTS_ALC_T_DIST_ENTRY (6612)
#define ERTS_ALC_T_NODE_ENTRY (6740)
#define ERTS_ALC_T_DRV_ENTRY_LIST (6868)
#define ERTS_ALC_T_ARG_REG (6932)
#define ERTS_ALC_T_PROC_DICT (7060)
#define ERTS_ALC_T_CALLS_BUF (7188)
#define ERTS_ALC_T_BPD (7380)
#define ERTS_ALC_T_PORT_NAME (7508)
#define ERTS_ALC_T_LINEBUF (7636)
#define ERTS_ALC_T_IOQ (7764)
#define ERTS_ALC_T_BITS_BUF (7892)
#define ERTS_ALC_T_DDLL_PROCESS (8020)
#define ERTS_ALC_T_DDLL_HANDLE (8148)
#define ERTS_ALC_T_PORT_DATA_LOCK (8276)
#define ERTS_ALC_T_NODES_MON (8340)
#define ERTS_ALC_T_DRV_THR_OPTS (8532)
#define ERTS_ALC_T_DRV_TID (8660)
#define ERTS_ALC_T_DRV_MTX (8788)
#define ERTS_ALC_T_DRV_CND (8916)
#define ERTS_ALC_T_DRV_RWLCK (9044)
#define ERTS_ALC_T_DRV_TSD (9172)
#define ERTS_ALC_T_PORT_LOCK (9300)
#define ERTS_ALC_T_DRIVER_LOCK (9428)
#define ERTS_ALC_T_LL_PTIMER (9556)
#define ERTS_ALC_T_FD_ENTRY_BUF (9684)
#define ERTS_ALC_T_PRT_REP_EXIT (9812)
#define ERTS_ALC_T_ATOM_TXT (9925)
#define ERTS_ALC_T_BIF_TIMER_TABLE (10069)
#define ERTS_ALC_T_ATOM_TABLE (10181)
#define ERTS_ALC_T_EXPORT_TABLE (10341)
#define ERTS_ALC_T_MODULE_TABLE (10469)
#define ERTS_ALC_T_PROC_TABLE (10517)
#define ERTS_ALC_T_PORT_TABLE (10709)
#define ERTS_ALC_T_TIMER_WHEEL (10837)
#define ERTS_ALC_T_CODE (10981)
#define ERTS_ALC_T_ASYNC_Q (11093)
#define ERTS_ALC_T_DB_TABLES (11173)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (11301)
#define ERTS_ALC_T_INSTR_INFO (11477)
#define ERTS_ALC_T_SCHDLR_DATA (11541)
#define ERTS_ALC_T_DDLL_ERRCODES (11733)
#define ERTS_ALC_T_PROC_LCK_WTR (11861)
#define ERTS_ALC_T_PROC_LCK_QS (11989)
#define ERTS_ALC_T_FP_EXCEPTION (12117)
#define ERTS_ALC_T_DRV_TAB (12245)
#define ERTS_ALC_T_DRV_EV_STATE (12373)
#define ERTS_ALC_T_POLLSET (12501)
#define ERTS_ALC_T_POLL_FDS (12629)
#define ERTS_ALC_T_POLL_RES_EVS (12757)
#define ERTS_ALC_T_FD_STATUS (12885)
#define ERTS_ALC_T_FD_TAB (13013)
#define ERTS_ALC_T_CS_PROG_PATH (13141)
#define ERTS_ALC_T_HEAP (13206)
#define ERTS_ALC_T_OLD_HEAP (13334)
#define ERTS_ALC_T_HEAP_FRAG (13462)
#define ERTS_ALC_T_DB_SEG (13607)
#define ERTS_ALC_T_DB_SEG_TAB (13735)
#define ERTS_ALC_T_DB_STK (13863)
#define ERTS_ALC_T_DB_TRANS_TAB (13991)
#define ERTS_ALC_T_DB_SEL_LIST (14119)
#define ERTS_ALC_T_DB_DMC_ERROR (14247)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (14375)
#define ERTS_ALC_T_DB_TERM (14503)
#define ERTS_ALC_T_PROC (14616)
#define ERTS_ALC_T_ATOM (14792)
#define ERTS_ALC_T_EXPORT (14952)
#define ERTS_ALC_T_MODULE (15080)
#define ERTS_ALC_T_REG_PROC (15128)
#define ERTS_ALC_T_MONITOR_SH (15256)
#define ERTS_ALC_T_NLINK_SH (15384)
#define ERTS_ALC_T_PROC_LIST (15512)
#define ERTS_ALC_T_FUN_ENTRY (15720)
#define ERTS_ALC_T_DB_TABLE (15784)
#define ERTS_ALC_T_DRV_EV_D_STATE (15960)
#define ERTS_ALC_T_DRV_SEL_D_STATE (16088)
#define ERTS_ALC_T_DRV_BINARY (16185)
#define ERTS_ALC_T_BINARY (16313)
#define ERTS_ALC_T_DRV (16474)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (8)
#define ERTS_ALC_T_BITS (15)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (255)
#define ERTS_ALC_T_MASK (32767)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_ETHR_INTERNAL,
  ERTS_ALC_T_HIPE,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_PORT_CALL_BUF,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PORT_TASKQ,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_XPORTS_LIST,
  ERTS_ALC_T_SL_PTIMER,
  ERTS_ALC_T_SYS_MSG_Q,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_DRV_ENTRY_LIST,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_PORT_NAME,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_PORT_LOCK,
  ERTS_ALC_T_DRIVER_LOCK,
  ERTS_ALC_T_LL_PTIMER,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_ASYNC_Q,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_PROC_LCK_WTR,
  ERTS_ALC_T_PROC_LCK_QS,
  ERTS_ALC_T_FP_EXCEPTION,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "async",
  "info_dsbuf",
  "ethread_internal",
  "hipe_data",
  "environment",
  "putenv_string",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "port_call_buf",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "sys_read_buf",
  "pending_suspend",
  "msg_ref",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "port_task",
  "port_task_queue",
  "misc_op_list",
  "port_names",
  "extra_port_list",
  "ptimer_sl",
  "system_messages_queue",
  "fd_list",
  "pollset_update_req",
  "link_lh",
  "monitor_lh",
  "nlink_lh",
  "suspend_monitor",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "drv_entry_list",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "port_name",
  "line_buf",
  "io_queue",
  "bits_buf",
  "ddll_processes",
  "ddll_handle",
  "port_data_lock",
  "nodes_monitor",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  "port_lock",
  "driver_lock",
  "ptimer_ll",
  "fd_entry_buf",
  "port_report_exit",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "code",
  "async_queue",
  "db_tabs",
  "db_match_pseudo_proc",
  "instr_info",
  "scheduler_data",
  "ddll_errcodes",
  "proc_lock_waiter",
  "proc_lock_queues",
  "fp_exception",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "fd_tab",
  "cs_prog_path",
  "heap",
  "old_heap",
  "heap_frag",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "atom_entry",
  "export_entry",
  "module_entry",
  "reg_proc",
  "monitor_sh",
  "nlink_sh",
  "proc_list",
  "fun_entry",
  "db_tab",
  "driver_event_data_state",
  "driver_select_data_state",
  "drv_binary",
  "binary",
  "drv_internal",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "binary_data",
  "atom_data",
  "system_data",
  "code_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "binary_alloc",
  "driver_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
